<Cabbage>
form caption("Tinny") size(700, 300) colour(58, 110, 182) guiMode("queue") pluginId("TNNY")

image bounds(0, 0, 700, 300) channel("aWindow") colour(255, 255, 255, 127) visible(1)
{

}

</Cabbage>
<CsoundSynthesizer>
<CsOptions>
-n -d -+rtmidi=NULL -M0 -m0d --midi-key-cps=4 --midi-velocity-amp=5 --displays
</CsOptions>
<CsInstruments>
; Initialize the global variables. 
ksmps = 32
nchnls = 2
0dbfs = 1

#include "creator.csdx"

opcode createEarFilters3, 0, iiiiSSi
    iX, iY, iW, iH, STag, SParent, iFilterCount xin
    
    x_makeit "image", x_6str(x_bounds(iX, iY, iW, iH), x_channel(STag), x_parent(SParent), x_colour(128, 220, 128, 255), "", "")
    x_makeit "label", x_6str(x_bounds(10, 10, 180, 16), x_channel(sprintf("%slab", STag)), x_parent(STag), x_fontColour(0, 0, 0, 255), x_text(sprintf("%s ear filter control", STag)), "")
    
    iXStep = iW / (iFilterCount + 2)
    iCount = 0
    iX = iXStep
    while iCount < iFilterCount do
        ; verticle sliders
        x_makeit "vslider", x_6str(x_bounds(iX, 22, int(iXStep - .5), int(iH * .65)), x_channel(sprintf("%s%dgain", STag, iCount + 1)), x_parent(STag), x_range(0, 2, 1, 1, 0.001), "", "")
        
        iX = iX + iXStep
        iCount = iCount + 1
    od
    x_makeit "hrange", x_3str(x_bounds(iXStep, int(iH * .8), iXStep * iFilterCount, 12), x_channel(sprintf("%scenterfreq", STag)), x_parent(STag))
endop

opcode initGui, 0, 0
    ; make source signal viewers
    ;; waveform view
    SParent = "aWindow"
    
    x_makeit "signaldisplay", x_9str(x_bounds(0, 0, 250, 150), x_channel("wavedisplay"), x_parent(SParent), x_colour(255, 255, 255, 255), x_backgroundColour(255, 0, 0, 255), x_displayType("waveform"), x_signalVariable("aMono"), x_zoom(-1), "")
    x_makeit "signaldisplay", x_9str(x_bounds(0, 150, 250, 150), x_channel("wavespectrogram"), x_parent(SParent), x_colour(255, 255, 255, 255), x_backgroundColour(255, 127, 127, 255), x_displayType("spectroscope"), x_signalVariable("aMono"), "", "")
    
    SRadioGroup = x_radioGroup("source")
    x_makeit "checkbox", x_6str(x_bounds(256, 28, 100, 12), x_channel("voicesrc"), x_parent(SParent), SRadioGroup, x_fontColour(255, 255, 255, 255), x_text("voice"))
    x_makeit "checkbox", x_6str(x_bounds(256, 44, 100, 12), x_channel("noisesrc"), x_parent(SParent), x_radioGroup(SRadioGroup), x_fontColour(255, 255, 255, 255), x_text("noise"))
    x_makeit "checkbox", x_6str(x_bounds(350, 28, 100, 12), x_channel("earlink"), x_parent(SParent), x_fontColour(255, 255, 255, 255), x_text("ear link"), "")
    x_makeit "checkbox", x_6str(x_bounds(350, 44, 100, 12), x_channel("randomize"), x_parent(SParent), x_fontColour(255, 255, 255, 255), x_text("randomize"), "")
    
    ;; left and right ear filter controls
    iEars = 2
    SEars[] fillarray "left", "right"
    iEarCount = 0
    iEarFilterCount = 12
    iY = 60
    while iEarCount < iEars do
        createEarFilters3 250, iY, 200, 120, SEars[iEarCount], SParent, iEarFilterCount
        iY = iY + 120
        iEarCount = iEarCount + 1
    od
    
    ; make output spectrum viewers
    ;; left
    x_makeit "signaldisplay", x_9str(x_bounds(450, 0, 250, 150), x_channel("leftear"), x_parent(SParent), x_colour(255, 255, 255, 255), x_backgroundColour(0, 255, 0, 255), x_displayType("spectroscope"), x_signalVariable("aLeft"), x_zoom(-1), "")
    ;; right
    x_makeit "signaldisplay", x_9str(x_bounds(450, 150, 250, 150), x_channel("rightear"), x_parent(SParent), x_colour(255, 255, 255, 255), x_backgroundColour(0, 0, 255, 255), x_displayType("spectroscope"), x_signalVariable("aRight"), x_zoom(-1), "")
endop

;; this is used to control whether the audio output is the voice recording or the noise source
;; when it is 0, the voice will be at full volume
chn_k "AudioGate", 3


;instrument will be triggered by keyboard widget
instr Builder
    initGui
    
    ; set the defaults
;    cabbageSetValue "left1", 1
;    cabbageSetValue "right1", 1
    cabbageSetValue "voicesrc", 1
endin

gSWordFiles[] init 5
gSWordFiles[0] = "oneA.wav"
gSWordFiles[1] = "twoA.wav"
gSWordFiles[2] = "threeA.wav"
gSWordFiles[3] = "fourA.wav"
gSWordFiles[4] = "fiveA.wav"


instr Main
    iFilterCount = 8
    SLeftChannels[] init iFilterCount
    SRightChannels[] init iFilterCount
    iCount = 0
    iX = 0
    iY = 0
    iWordCount lenarray gSWordFiles
    while iCount < iFilterCount do
        SLeftChannels[iCount] sprintf "leftband%d", iCount + 1
        SRightChannels[iCount] sprintf "rightband%d", iCount + 1
        iCount = iCount + 1
    od
    
    kLeftFilterSelect init 0
    kRightFilterSelect init 0
    kLeftTrig init 0
    kRightTrig init 0
    kSrcSelect init 0   ; 0 = voice 1 = noise
    kAudioGate init 0
    kAudioGateStep init (1 / kr)
    kWordIndex init 0   ; index to the name of the word file to play
    kWordEar init 0     ; which ear is the word being sent to
    
    kVoiceSrc, kVoiceSrcTrig cabbageGetValue "voicesrc"
    kNoiseSrc, kNoiseSrcTrig cabbageGetValue "noisesrc"
    
    kEarLink, kEarLinkTrig cabbageGetValue "earlink"
    kRandomize, kRandomizeTrig cabbageGetValue "randomize"
    
    if kSrcSelect == 1 then
        ; noise
        kAudioGate = kAudioGate - kAudioGateStep
        if kAudioGate < 0 then
            kAudioGate = 0
        endif
    else
        ; voice
        kAudioGate = kAudioGate + kAudioGateStep
        if kAudioGate > 1 then
            kAudioGate = 1
        endif
        if metro(.5) == 1 then
            ; play a word file (p4 = word index, p5 = left0/right1 panning
            event "i", "Voice", 0, -1, kWordIndex, kWordEar
            ; change the word
            kWordIndex = kWordIndex + 1
            if kWordIndex == iWordCount then
                kWordIndex = 0
            endif
            ; change ears
            kWordEar = (kWordEar == 1 ? 0 : 1)
        endif
    endif
    chnset kAudioGate, "AudioGate"
    
    if kRandomizeTrig == 1 then
        printks "Randomize: %d %d\n", 0, kRandomize, kRandomizeTrig
        if kRandomize == 1 then
            printks "doing randomization.\n", 0
            cabbageSetValue "randomize", 0
        endif
    endif
endin

instr ShowWidgetChannels
    SChannels[] cabbageGetWidgetChannels
    iLen lenarray SChannels
    iCount = 0
    while iCount < iLen do
        prints "str: %s\n", SChannels[iCount]
        iCount = iCount + 1
    od
endin

chn_a "WordLeft", 3
chn_a "WordRight", 3

instr Voice
    iWordIndex = p4
    iWordEar = p5
    
    prints "index: %d %s ear: %d\n", iWordIndex, gSWordFiles[iWordIndex], iWordEar
    
    kSpeed init 1
    iSkip init 0
    iLoop init 0
    aWord diskin2 gSWordFiles[iWordIndex], kSpeed, iSkip, iLoop
    
    if iWordEar == 0 then
        chnset aWord, "WordLeft"
    else
        chnset aWord, "WordRight"
    endif
endin

instr Mixer
    iBeta = 0
    kAudioGate chnget "AudioGate"
    iFilterCount init 8
    kLeftFilter[][] init iFilterCount, 3
    kRightFilter[][] init iFilterCount, 3
    SLeftChans[][] init iFilterCount, 3
    SRightChans[][] init iFilterCount, 3
    iCount = 0
    while iCount < iFilterCount do
        SLeftChans[iCount][0] sprintf "leftband%dcenter", iCount + 1
        SLeftChans[iCount][1] sprintf "leftband%dwidth", iCount + 1
        SLeftChans[iCount][2] sprintf "leftband%dgain", iCount + 1
        SRightChans[iCount][0] sprintf "rightband%dcenter", iCount + 1
        SRightChans[iCount][1] sprintf "rightband%dwidth", iCount + 1
        SRightChans[iCount][2] sprintf "rightband%dgain", iCount + 1
        
        prints "%s %s %s %s %s %s\n", SLeftChans[iCount][0], SLeftChans[iCount][1], SLeftChans[iCount][2], SRightChans[iCount][0], SRightChans[iCount][1], SRightChans[iCount][2]
        
        iCount = iCount + 1
    od
    
    kCount = 0
    while kCount < iFilterCount do
        kLeftFilter[kCount][0] cabbageGetValue SLeftChans[kCount][0]
        kLeftFilter[kCount][1] cabbageGetValue SLeftChans[kCount][1]
        kLeftFilter[kCount][2] cabbageGetValue SLeftChans[kCount][2]
        kRightFilter[kCount][0] cabbageGetValue SRightChans[kCount][0]
        kRightFilter[kCount][1] cabbageGetValue SRightChans[kCount][1]
        kRightFilter[kCount][2] cabbageGetValue SRightChans[kCount][2]
        
        kCount = kCount + 1
    od
    
    kNoiseGate = abs(kAudioGate - 1)
    aNoiseLeft noise kNoiseGate, iBeta
    aNoiseRight noise kNoiseGate, iBeta
    
    aWordLeft chnget "WordLeft"
    aWordRight chnget "WordRight"
    
    chnclear "WordLeft", "WordRight"
    
    aLeft = (aWordLeft * kAudioGate) + aNoiseLeft
    aRight = (aWordRight * kAudioGate) + aNoiseRight
    
    aMono = ((aWordLeft + aWordRight) * kAudioGate) + aNoiseLeft
    
    if metro(4) == 1 then
        printks "%f %f %f\n", 0, kLeftFilter[0][0], kLeftFilter[0][1], kLeftFilter[0][2]
    endif
    
    aLeft2 eqfil aLeft, kLeftFilter[0][0], kLeftFilter[0][1], kLeftFilter[0][2]
    aLeft2 eqfil aLeft2, kLeftFilter[1][0], kLeftFilter[1][1], kLeftFilter[1][2]
    aLeft2 eqfil aLeft2, kLeftFilter[2][0], kLeftFilter[2][1], kLeftFilter[2][2]
    aLeft2 eqfil aLeft2, kLeftFilter[3][0], kLeftFilter[3][1], kLeftFilter[3][2]
    aLeft2 eqfil aLeft2, kLeftFilter[4][0], kLeftFilter[4][1], kLeftFilter[4][2]
    aLeft2 eqfil aLeft2, kLeftFilter[5][0], kLeftFilter[5][1], kLeftFilter[5][2]
    
    aRight2 eqfil aRight, kRightFilter[0][0], kRightFilter[0][1], kRightFilter[0][2]
    aRight2 eqfil aRight2, kRightFilter[1][0], kRightFilter[1][1], kRightFilter[1][2]
    aRight2 eqfil aRight2, kRightFilter[2][0], kRightFilter[2][1], kRightFilter[2][2]
    aRight2 eqfil aRight2, kRightFilter[3][0], kRightFilter[3][1], kRightFilter[3][2]
    aRight2 eqfil aRight2, kRightFilter[4][0], kRightFilter[4][1], kRightFilter[4][2]
    aRight2 eqfil aRight2, kRightFilter[5][0], kRightFilter[5][1], kRightFilter[5][2]
    
    out aLeft2, aRight2
    
    display aMono, .05
    dispfft aMono, 2, 1024
    dispfft aLeft, 2, 1024
    dispfft aRight, 2, 1024
endin

</CsInstruments>
<CsScore>
;causes Csound to run for about 7000 years...

i "Builder" 0 0

i "Main" 0 -1

i "Mixer" 1 -1

i "ShowWidgetChannels" 1 0

f0 z
</CsScore>
</CsoundSynthesizer>
